import { IStoreValue } from "./istore_value";
import { StoreValueAddress } from "./store_value_address";
import { ArrayType } from "../../../typeSystem/array_type";

export class ArrayStoreValueRef implements IStoreValue {

  public isConst = false;

  constructor(public type: ArrayType, public values: StoreValueAddress[],
    private loc_address: number[], public lines: number, public columns:number, public id:String) { }

  get () {
    return this.values;
  }

  getRefAddresses () : number[] {
    return this.loc_address;
  }

  inStore () {
    return this.id != null;
  }
}